package cn.net.caoyao.cpzshandset.service.thread.impl.commonfarmers;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;

import android.os.Handler;
import android.os.Message;
import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.service.bll.ActivateBll;
import cn.net.caoyao.cpzshandset.service.bll.BatchLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20002ReqBatchBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20044ReqBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20044FarmersActivate;

public class CommonFarmersSubmitSingleBatchActivateThread implements Runnable {
	private long deviceId;
	private ActivateBll bll;
	private BatchLabelBll batchBll;
	private UploadStatusBll uploadStatusBll;
	private ActivateBean activateBean;
	private Prot20002ReqBatchBean batchBean;
	private Handler mHandler;
	private int option_type = HandsetOperation.OPERATION_ACTIVATE_CONSTANT.getOption();

	public CommonFarmersSubmitSingleBatchActivateThread(Handler mHandler, long deviceId, ActivateBll bll,
			BatchLabelBll batchBll, UploadStatusBll uploadStatusBll, ActivateBean activateBean,
			Prot20002ReqBatchBean batchBean) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.uploadStatusBll = uploadStatusBll;
		this.activateBean = activateBean;
		this.batchBean = batchBean;
		this.batchBll = batchBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
		try {
			LogUtil.d(TConfig.Echo, "登录");
			create.createLoginCpzsHandset(deviceId);
			if (create.isResult()) {
				submitActivateInfo(create);
			} else {
				Message msg = new Message();
				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				msg.arg1 = create.getiErrCode();
				msg.obj = create.getErrMsg();
				mHandler.sendMessage(msg);
			}

		} catch (BindException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (ConnectException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally {
			new Prot02Logout().dealLogout(create);
		}
	}

	private void submitActivateInfo(SocketCreate create) throws IOException, SocketTimeoutException {
		Prot20044FarmersActivate activate = new Prot20044FarmersActivate();
		activate.submitActivateInfo(create, getReqBean());
		ProtStatusResBean resBean = activate.getResBean();
		if (resBean == null) {
			mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ACTIVATE_WITHOUT_RES);
			return;
		}
		
		LogUtil.d(TConfig.Echo, "批量激活：" + resBean.toString());

		if (resBean.getResult() == 0) {
			// 上传成功，插入记录到提交状态表
			uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
			bll.delActivateById(activateBean);
			// bll.delActivateById(activateBean.getId());
			// batchBll.deleteBatchById(HansetOperationConstant.OPERATION_ACTIVATE_CONSTANT,
			// activateBean.getId());
		} else {
			batchBll.insertBatch(option_type, activateBean.getId(), batchBean);
			bll.updateActivateErrorById(resBean.getErrcode(), activateBean.getId());
			LogUtil.i(TConfig.Echo, "else activateId:" + activateBean.toString());
		}
		Message msg = mHandler.obtainMessage(RequestConstant.SUBMIT_ACTIVATE_WITH_RES);
		msg.obj = resBean;
		msg.what = RequestConstant.SUBMIT_ACTIVATE_WITH_RES;
		mHandler.sendMessage(msg);

	}

	private UploadBean getUploadBean(ActivateBean activateBean) {
		UploadBean b = new UploadBean();
		b.setLabel_count(batchBll.queryBatchCountById(option_type, activateBean.getId()));
		b.setOption_type(option_type);
		return b;
	}

	private Prot20044ReqBean getReqBean() {
		Prot20044ReqBean reqBean = new Prot20044ReqBean();
		reqBean.setProduct_id(activateBean.getProduct_id());
		reqBean.setProducer(activateBean.getProducer());
		reqBean.setProduce_date(activateBean.getProduct_date());
		reqBean.setProduce_batch(activateBean.getProduct_batch_number());
		reqBean.setBreed_id(activateBean.getFarmerID());
		reqBean.setType(Config.BATCH_OPTION_LABEL_TYPE);
		reqBean.setBatcher(batchBean);
		LogUtil.i(TConfig.Echo, "提交的数据：" + reqBean.toString());
		return reqBean;
	}

}
